Index: src/edu/ucsb/nceas/metacat/QuerySpecification.java
===================================================================
--- src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 180)
+++ src/edu/ucsb/nceas/metacat/QuerySpecification.java	(revision 181)
@@ -70,6 +70,9 @@
 
     // Initialize the parser and read the queryspec
     Parser parser = initializeParser();
+    if (parser == null) {
+      System.err.println("SAX parser not instantiated properly.");
+    }
     try {
       parser.parse(new InputSource(queryspec));
     } catch (SAXException e) {
@@ -105,6 +108,16 @@
          FileReader xml = new FileReader(new File(xmlfile));
          QuerySpecification qspec = new QuerySpecification(xml, DEFAULT_PARSER);
          System.out.println(qspec.printSQL());
+
+         // Also test the XML formatting function of DBQuery
+/*
+         System.out.println(DBQuery.createQuery("mysearchvalue", "mydoctype"));
+         StringReader xml2 = new StringReader(
+                      DBQuery.createQuery("mysearchvalue", "mydoctype"));
+         QuerySpecification qspec2 = 
+                      new QuerySpecification(xml2, DEFAULT_PARSER);
+         System.out.println(qspec2.printSQL());
+*/
        } catch (IOException e) {
          System.err.println(e.getMessage());
        }
Index: src/edu/ucsb/nceas/metacat/DBQuery.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 180)
+++ src/edu/ucsb/nceas/metacat/DBQuery.java	(revision 181)
@@ -74,10 +74,10 @@
                               dbstring, user, password);
 
           // Execute the query
-          DBQuery rd = new DBQuery(dbconn, parser);
+          DBQuery queryobj = new DBQuery(dbconn, parser);
           FileReader xml = new FileReader(new File(xmlfile));
           Hashtable nodelist = null;
-          nodelist = rd.findDocuments(xml);
+          nodelist = queryobj.findDocuments(xml);
 
           // Print the reulting document listing
           StringBuffer result = new StringBuffer();
@@ -181,4 +181,51 @@
       }
     return docListResult;
   }
+
+  /**
+   * format a simple free-text value query as an XML document that conforms
+   * to the pathquery.dtd and is appropriate for submission to the DBQuery
+   * structured query engine
+   *
+   * @param value the text string to search for in the xml catalog
+   * @param doctype the type of documents to include in the result set -- use
+   *        "any" or "ANY" for unfiltered result sets
+   */
+   public static String createQuery(String value, String doctype) {
+     StringBuffer xmlquery = new StringBuffer();
+     xmlquery.append("<?xml version=\"1.0\"?>\n");
+     xmlquery.append("<!DOCTYPE pathquery PUBLIC ");
+     xmlquery.append("\"-//NCEAS//pathquery-1.0//EN\" ");
+     xmlquery.append("\"http://24.237.19.164/xmltodb/lib/pathquery.dtd\" >");
+     xmlquery.append("<pathquery version=\"1.0\">");
+     xmlquery.append("<meta_file_id>Unspecified</meta_file_id>");
+     xmlquery.append("<querytitle>Unspecified</querytitle>");
+
+     if (!doctype.equals("any") && !doctype.equals("ANY")) {
+       xmlquery.append("<returndoctype>");
+       xmlquery.append(doctype).append("</returndoctype>");
+     }
+
+     xmlquery.append("<querygroup operator=\"UNION\">");
+     xmlquery.append("<queryterm casesensitive=\"false\" ");
+     xmlquery.append("searchmode=\"contains\">");
+     xmlquery.append("<value>").append(value).append("</value>");
+     xmlquery.append("</queryterm>");
+     xmlquery.append("</querygroup>");
+     xmlquery.append("</pathquery>");
+
+     
+     return (xmlquery.toString());
+   }
+
+  /**
+   * format a simple free-text value query as an XML document that conforms
+   * to the pathquery.dtd and is appropriate for submission to the DBQuery
+   * structured query engine
+   *
+   * @param value the text string to search for in the xml catalog
+   */
+   public static String createQuery(String value) {
+     return createQuery(value, "any");
+   }
 }
Index: src/edu/ucsb/nceas/metacat/MetaCatServlet.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 180)
+++ src/edu/ucsb/nceas/metacat/MetaCatServlet.java	(revision 181)
@@ -67,20 +67,23 @@
 
   private ServletConfig		config = null;
   private ServletContext	context = null;
-  Connection 		conn = null;
-  DBSimpleQuery		queryobj = null;
-  DBReader		docreader = null;
-  DBTransform		dbt = null;
-  String 	user = null;
-  String 	password = null;
-  String 	defaultDB = null;
-  String 	resultStyleURL = null;
-  String 	xmlcatalogfile = null;
-  String    defaultdatapath = null; // path to directory where data files 
-                                    // that can be downloaded will be stored
-  String    executescript  = null;  // script to get data file and put it 
-                                    // in defaultdocpath dir
-  PropertyResourceBundle options = null;
+  private Connection 		conn = null;
+  private DBQuery		queryobj = null;
+  private DBReader		docreader = null;
+  private DBTransform		dbt = null;
+  private String 		user = null;
+  private String 		password = null;
+  private String 		defaultDB = null;
+  private String 		resultStyleURL = null;
+  private String 		xmlcatalogfile = null;
+  private String 		saxparser = null;
+  private String    		defaultdatapath = null; 
+					// path to directory where data files 
+					// that can be downloaded will be stored
+  private String    		executescript  = null;  
+					// script to get data file and put it 
+                                    	// in defaultdocpath dir
+  private PropertyResourceBundle options = null;
 
   /**
    * Initialize the servlet by creating appropriate database connections
@@ -100,6 +103,7 @@
       defaultDB = (String)options.handleGetObject("defaultDB");
       resultStyleURL = (String)options.handleGetObject("resultStyleURL");
       xmlcatalogfile = (String)options.handleGetObject("xmlcatalogfile");
+      saxparser = (String)options.handleGetObject("saxparser");
       defaultdatapath = (String)options.handleGetObject("defaultdatapath");
       executescript = (String)options.handleGetObject("executescript");
 
@@ -109,7 +113,7 @@
                 "oracle.jdbc.driver.OracleDriver",
                 defaultDB, user, password);
 
-        queryobj = new DBSimpleQuery(conn);
+        queryobj = new DBQuery(conn,saxparser);
         docreader = new DBReader(conn);
         dbt = new DBTransform(conn);
 
@@ -152,7 +156,7 @@
                 "oracle.jdbc.driver.OracleDriver",
                 defaultDB, user, password);
   
-        queryobj = new DBSimpleQuery(conn);
+        queryobj = new DBQuery(conn, saxparser);
         docreader = new DBReader(conn);
         dbt = new DBTransform(conn);
   
@@ -210,7 +214,7 @@
       //out.println("<P>Caught exception looking for Y value.");
     }
 
-    if (action.equals("query")) {
+    if (action.equals("query") || action.equals("squery")) {
       handleQueryAction(out, params, response);
     } else if (action.equals("getdocument")) {
       try {
@@ -240,27 +244,38 @@
    */
   private void handleQueryAction(PrintWriter out, Hashtable params, 
                HttpServletResponse response) {
-      // Run the query
+      String action = ((String[])params.get("action"))[0];
+      String query = ((String[])params.get("query"))[0]; 
       Hashtable doclist = null;
-      String query = ((String[])params.get("query"))[0]; 
-      String[] doctypeArr = (String[])params.get("doctype");
+      String[] doctypeArr = null;
       String doctype = null;
-      if (doctypeArr != null) {
-        doctype = ((String[])params.get("doctype"))[0]; 
-      }
-      if (queryobj != null) {
+      Reader xmlquery = null;
+
+      // Run the query if it is a structured query
+      // or, if it is a free-text, simple query,
+      // format it first as a structured query and then run it
+      if (action.equals("query")) {
+        doctypeArr = (String[])params.get("doctype");
+        doctype = null;
+        if (doctypeArr != null) {
+          doctype = ((String[])params.get("doctype"))[0]; 
+        }
+
         if (doctype != null) {
-          doclist = queryobj.findDocuments(query,doctype);
+          xmlquery = new StringReader(DBQuery.createQuery(query,doctype));
         } else {
-          doclist = queryobj.findDocuments(query);
+          xmlquery = new StringReader(DBQuery.createQuery(query));
         }
+      } else if (action.equals("squery")) {
+        xmlquery = new StringReader(query);
       } else {
+        System.err.println("Error handling query -- illegal action value");
+      }
+
+      if (queryobj != null) {
+          doclist = queryobj.findDocuments(xmlquery);
+      } else {
         out.println("Query Object Init failed.");
-	/*
-        out.println(user);
-        out.println(defaultDB);
-        out.println(xmlcatalogfile);
-        */
         return;
       }
  
